#pragma once

#include <Text.h>
#include <Writer.h>
#include <Reader.h>

class ChatMessage : public virtual Framework::ReferenceCounter
{
private:
    __int64 time;
    Framework::Text message;
    Framework::Text channel;
    Framework::Text targetPlayerName;

public:
    ChatMessage(Framework::Text message,
        Framework::Text channel,
        Framework::Text targetPlayerName);
    ChatMessage(Framework::StreamReader* zReader);
    
    Framework::Text getChannel() const;
    Framework::Text getTargetPlayerName() const;
    void writeTo(Framework::StreamWriter* zWriter) const;
};