#pragma once

#include <Array.h>
#include <InMemoryBuffer.h>
#include <ReferenceCounter.h>
#include <Trie.h>

#include "ChunkMap.h"

class Dimension;
class NetworkMessage;
class Entity;

class DimensionMap : public Framework::ReferenceCounter
{
private:
    Framework::Trie<ChunkMap>* chunks;
    Framework::Critical cs;
    Framework::Array<int> observers;
    int dimensionId;

    ChunkMap* load(Framework::Punkt chunkCenter);

public:
    DimensionMap(int dimensionId);
    ~DimensionMap();

    void api(Framework::InMemoryBuffer* zRequest,
        NetworkMessage* zResponse,
        Entity* zSource,
        Dimension* zDimension);

    void loadMap(char* addr, int addrLen, Chunk* zChunk);
    void onMapUpdated(char* addr, int addrLen);
    void saveMap(char* addr, int addrLen);
    void removeMap(char* addr, int addrLen);
    ChunkMap* getMap(char* addr, int addrLen, Framework::Punkt chunkCenter);
};