#pragma once

#include "BiomGenerator.h"
#include "StaticRegistry.h"

class GrasslandBiom : public BiomGenerator
{
    Noise* heightNoise;
    Noise* undergroundDirdNoise;
    Noise* surfaceSandNoise;
    Noise* undergroundGravelNoise;
    Noise* grassNoise;
    // TODO: Noise* anySmallOreNoise;
    // TODO: add water rivers

public:
    GrasslandBiom();
    ~GrasslandBiom();
    Framework::Either<Block*, int> generateAboveSurfaceBlock(int x,
        int y,
        int z,
        int surfaceHeight,
        Chunk* partialGeneratedChunk) override;
    Framework::Either<Block*, int> generateSurfaceBlock(
        int x, int y, int z) override;
    Framework::Either<Block*, int> generateBelowSurfaceBlock(
        int x, int y, int z) override;
    Framework::Either<Block*, int> generateCaveBlock(
        int x, int y, int z) override;
    Framework::Either<Block*, int> generateUnderWaterBlock(int x,
        int y,
        int z,
        int surfaceHeight,
        Chunk* partialGeneratedChunk) override;
    Noise* zHeightMapNoise() override;
    void setSeed(int seed) override;
};