#pragma once

#include <Critical.h>
#include <Thread.h>

#include "Area.h"
#include "DimensionGenerator.h"

class WorldGenerator : public Framework::Thread
{
private:
    Framework::Critical cs;
    Framework::Array<Area> requestQueue;
    bool exit;
    int seed;

public:
    WorldGenerator(int seed);
    ~WorldGenerator();
    void thread() override;
    void requestGeneration(Area request);
    void exitAndWait();
    Framework::Either<Block*, int> generateSingleBlock(
        Framework::Vec3<int> location, int dimensionId);
    bool spawnStructure(Framework::Vec3<int> location,
        int dimensionId,
        std::function<bool(GenerationTemplate* tmpl)> filter);
};